Unit CrtFxLib;
Interface
{---------------------------------------------------------------------------}
CONST
  CRTCIndexRegister             = $03D4;
  CRTCLineLengthRegister        = $13;
{---------------------------------------------------------------------------}
Type
  CrtFxType                     = Object
                                    Width,Height    : Integer;
                                    VertInc,HorInc  : Byte;
                                    SCROffset       : Word;


                                    Constructor Init(w : Integer);
                                    Procedure   DisplayString(x,y,attr : Byte;Str : String);
                                    Procedure   Clear(attr : Byte);
                                    Procedure   FillRect(x1,y1,x2,y2,attr : Byte;cr : Char);
                                    Procedure   ScrollLeft;
                                    Procedure   ScrollRight;
                                    Procedure   ScrollDown;
                                    Procedure   ScrollUp;
                                    Procedure   HLine(x1,x2,y,attr : Byte;Double : Boolean);
                                    Procedure   VLine(x,y1,y2,attr : Byte;Double : Boolean);
                                    Procedure   Frame(x1,y1,x2,y2,attr : Byte;Double : Boolean);

                                    Destructor  Kill;

                                    Private

                                    Procedure  WaitRetraceStart;
                                    Procedure  WaitRetraceEnd;
                                  End;
VAR
  CRTFX   : CrtFxType;

Implementation

Constructor CrtFxType.Init;
var
  wd : Byte;
Begin
  asm
    MOV  ax,0003h
    int  10h
  end;
  wd:=w mod 256;
  portw[CrtcIndexRegister]:=(wd div 2) shl 8+CrtcLineLengthRegister;
  Width:=wd;
  height:=$8000 div (width*2);
  VertInc:=0;
  HorInc:=0;
  ScrOffset:=0;
end;
{---------------------------------------------------------------------------}
Procedure CrtFxType.DisplayString;
Var
  i         : Integer;
  offs      : Word;
Begin
  Offs:=y*(Width*2)+x*2;
  for i:=1 To Length(str) Do
  Begin
    mem[$B800:Offs]:=Ord(Str[i]);
    inc(offs);
    mem[$B800:offs]:=attr;
    inc(offs);
  End;
End;
{---------------------------------------------------------------------------}
Procedure CrtFxType.Clear;ASSEMBLER;
asm
  MOV  AX,0B800h
  MOV  ES,AX
  SUB  DI,DI
  MOV  AL,32
  MOV  AH,[attr]
  MOV  CX,8000h
  REP  STOSW
end;
{---------------------------------------------------------------------------}
Procedure CrtFxType.FillRect;
Var
  FillStr       : String;
  i             : Integer;
Begin
  FillStr:='';
  While Length(FillStr)<(x2-x1+1) do fillstr:=Fillstr+cr;
  For i:=y1 to y2 Do DisplayString(x1,i,attr,Fillstr);
End;
{---------------------------------------------------------------------------}
Procedure CrtFxType.ScrollLeft;
Begin
  If HorInc=7 then
  Begin
    Inc(scrOffset);
    WaitRetraceEnd;
    asm cli end;
    portw[CRTCIndexRegister]:=Hi(ScrOffset) shl 8+$0C;
    portw[CRTCIndexRegister]:=Lo(ScrOffset) shl 8+$0D;
    asm sti end;
    WaitRetraceStart;
    horinc:=0;
    port[$03C0]:=$33;
    port[$03C0]:=HorInc;
  End else
  Begin
    WaitRetraceStart;
    port[$03C0]:=$33;
    inc(horInc);
    port[$03C0]:=HorInc;
  End;
end;
{---------------------------------------------------------------------------}
Procedure CrtFxType.ScrollRight;
Begin
  If HorInc=0 then
  Begin
    dec(scrOffset);
    WaitRetraceEnd;
    asm cli end;
    portw[CRTCIndexRegister]:=Hi(ScrOffset) shl 8+$0C;
    portw[CRTCIndexRegister]:=Lo(ScrOffset) shl 8+$0D;
    asm sti end;
    WaitRetraceStart;
    horinc:=7;
    port[$03C0]:=$33;
    port[$03C0]:=HorInc;
  End else
  Begin
    WaitRetraceStart;
    port[$03C0]:=$33;
    dec(horInc);
    port[$03C0]:=HorInc;
  End;
end;
{---------------------------------------------------------------------------}
Procedure CrtFxType.ScrollUp;
Begin
  If VertInc=15 then
  Begin
    Inc(scrOffset,width);
    WaitRetraceEnd;
    asm cli end;
    portw[CRTCIndexRegister]:=Hi(ScrOffset) shl 8+$0C;
    portw[CRTCIndexRegister]:=Lo(ScrOffset) shl 8+$0D;
    asm sti end;
    WaitRetraceStart;
    Vertinc:=0;
    portw[$03D4]:=vertinc shl 8+$08;
  End else
  Begin
    WaitRetraceStart;
    inc(vertinc);
    portw[$03D4]:=vertinc shl 8+$08;
  End;
end;
{---------------------------------------------------------------------------}
Procedure CrtFxType.ScrollDown;
Begin
  If VertInc=0 then
  Begin
    dec(scrOffset,width);
    WaitRetraceEnd;
    asm cli end;
    portw[CRTCIndexRegister]:=Hi(ScrOffset) shl 8+$0C;
    portw[CRTCIndexRegister]:=Lo(ScrOffset) shl 8+$0D;
    asm sti end;
    WaitRetraceStart;
    Vertinc:=15;
    portw[$03D4]:=vertinc shl 8+$08;
  End else
  Begin
    WaitRetraceStart;
    dec(vertinc);
    portw[$03D4]:=vertinc shl 8+$08;
  End;
end;
{---------------------------------------------------------------------------}
Destructor crtfxtype.kill;
Begin
  asm
    MOV  ax,0003h
    int  10h
  end;
  portw[CrtcIndexRegister]:=40 shl 8+CrtcLineLengthRegister;
  ScrOffset:=0;
  WaitRetraceEnd;
  asm cli end;
  portw[CRTCIndexRegister]:=Hi(ScrOffset) shl 8+$0C;
  portw[CRTCIndexRegister]:=Lo(ScrOffset) shl 8+$0D;
  asm sti end;
  WaitRetraceStart;
  Vertinc:=0;
  portw[$03D4]:=$0008;
  port[$03C0]:=$33;
  port[$03C0]:=vertInc;
end;
{---------------------------------------------------------------------------}
Procedure CrtFxType.HLine;
Var
  ProtoType     : Char;
  i             : Integer;
Begin
  If Double Then ProtoType:='' else ProtoType:='';
  For i:=x1 to x2 Do DisplayString(i,y,attr,Prototype);
End;
{---------------------------------------------------------------------------}
Procedure CrtFxType.VLine;
Var
  ProtoType     : Char;
  i             : Integer;
Begin
  If Double Then ProtoType:='' else ProtoType:='';
  For i:=y1 to y2 Do DisplayString(x,i,attr,ProtoType);
End;
{---------------------------------------------------------------------------}
Procedure CrtFxType.Frame;
Var
  ProtoType     : String;
Begin
  If Double Then ProtoType:='ɻȼ' else ProtoType:='ڿ';
  Hline(x1+1,x2-1,y1,attr,double);
  Hline(x1+1,x2-1,y2,attr,double);
  VLine(x1,y1+1,y2-1,attr,double);
  VLine(x2,y1+1,y2-1,attr,double);
  DisplayString(x1,y1,attr,ProtoType[1]);
  DisplayString(x2,y1,attr,ProtoType[2]);
  DisplayString(x1,y2,attr,ProtoType[3]);
  DisplayString(x2,y2,attr,ProtoType[4]);
End;
{---------------------------------------------------------------------------}
Procedure CrtFXType.WaitRetraceStart;
begin
  Repeat until port[$03DA] and 8=8;
end;
{---------------------------------------------------------------------------}
Procedure CrtFxType.WaitRetraceEnd;
begin
  WaitRetraceStart;
  repeat until Port[$03DA] and 8=0;
end;

end.