PROGRAM Pixeldem;
USES Graph, Crt, Bgidriv;

PROCEDURE Vgamode;
VAR Gdriver, Gmode : INTEGER;
BEGIN
  IF REGISTERBGIDRIVER(@Egavgadriverproc) < 0 THEN
  BEGIN
    CLRSCR; TEXTATTR:= 14;
    WRITELN('Sorry, keine VGA-Karte gefunden.');
    HALT;
  END;
  Gdriver:= DETECT;
  INITGRAPH(Gdriver, Gmode, '');
END;

PROCEDURE _Putpixel(X, Y : INTEGER; COLOR : BYTE); ASSEMBLER;
ASM
  MOV  AX, 0A000h       { Videosegment-Adresse nach AX                       }
  MOV  ES, AX           { bertragen ins Extra-Segment-Register              }
  MOV  AX, Y            { y-Koordinate nach AX zur Berechnung des Offset     }
  MOV  DI, AX           { \                                                  }
  MOV  CL, 06h          {  |                                                 }
  SHL  AX, CL           {   > DI=(y*64)+(y*16)=y*80                          }
  MOV  CL, 04h          {  |                                                 }
  SHL  DI, CL           {  |                                                 }
  ADD  DI, AX           { /                                                  }
  MOV  AX, X            { \                                                  }
  SHR  AX, 1            {  |                                                 }
  SHR  AX, 1            {   > DI=DI+(x div 8)=y*80+x div 8=Offset            }
  SHR  AX, 1            {  |                                                 }
  ADD  DI, AX           { /                                                  }
  MOV  CX, X            { x nach CX zur Berechnung der Bitmaske              }
  AND  CL, 7            { CX:=CX and 7                                       }
  XOR  CL, 7            { CX:=CX xor 7=(x and 7) xor 7                       }
  MOV  AH, 01h          { \                                                  }
  SHL  AH, CL           { - AH:=1 shl ((x and 7) xor 7)= Bitmaske            }
  MOV  DX, 03CEh        { DX auf Protadresse des GDC                         }
  MOV  AL, 08h          { Zugriff auf das Bitmap-register des GDC            }
  OUT  DX, AX           { Schreibzugriff ausfhren                           }
  MOV  AX, 0205h        { Graphmode-register des GDC auf write-mode 2 setzen }
  OUT  DX, AX           { Schreibzugriff ausfhren                           }
  MOV  AX, 0003h        { function select-register des GDC auf ersetzen      }
  OUT  DX, AX           { Schreibzugriff ausfhren                           }
  SEGES
  MOV  AL, [DI]         { Daten byte aus dem Video-RAM laden                 }
  MOV  AL, COLOR        { Farbe nach AL                                      }
  STOSB                 { AL in den Video-Speicher bertragen                }
END;

VAR Loopx, Loopy   : INTEGER;
BEGIN
  CLRSCR; TEXTATTR:=$1F;
  WRITE('********************************************************************************');
  WRITE('**   Programmers DiskMAG                                Pixel-Demonstration   **');
  WRITE('**   ----------------------------------------------------------------------   **');
  WRITE('**   Dieses Programm demonstriert den Vorteil einer direkt ber die VGA-Re-   **');
  WRITE('**   gister programmierten Pixelsetzroutine gegenber der PutPixel-Prozedur   **');
  WRITE('**   der GRAPH-Unit.                                                          **');
  WRITE('**   ----------------------------------------------------------------------   **');
  WRITE('**   (c) 1994 by DJ ByteDisaster for     BSR-SOTWARGroup Genthin/Erxleben   **');
  WRITE('********************************************************************************');
  TEXTATTR:= $0F;
  WRITELN;
  WRITELN;
  WRITELN('Der Bildschirm wird jetzt 2x gefllt werden :');
  WRITELN;
  WRITELN(' 1. Mit der PutPixel-Prozedur der GRAPH.TPU in der Farbe gelb,');
  WRITELN(' 2. Mit der direkt programmierten _PutPixel-Routine in blau.');
  WRITELN; WRITELN;
  WRITELN('                 ***  Bitte RETURN drcken  ***'); REPEAT UNTIL READKEY= #13;
  Vgamode; OUTTEXTXY(200, 200, 'Fllen mit Putpixel(x,y,color)');
  FOR Loopx:= 0 TO 639 DO
    FOR Loopy:= 0 TO 479 DO
      PUTPIXEL(Loopx, Loopy, YELLOW);
  REPEAT UNTIL READKEY<>#0;
  SETCOLOR(0);
  OUTTEXTXY(200, 200, 'Fllen mit _Putpixel(x,y,color)');
  FOR Loopx:= 0 TO 639 DO
    FOR Loopy:= 0 TO 479 DO
      _Putpixel(Loopx, Loopy, BLUE);
  TEXTMODE(Co80);
  WRITELN('Sie haben den Unterschied (hoffen wir) gesehen.');
  WRITE  ('Die direkte Programmierung der VGA-Karte bietet Ihnen die Mglichkeit,Funktionen');
  WRITELN('mehr als 100% schneller auszufhren, was bei komplexeren Programm-Projekten zum');
  WRITELN('Teil deutliche Verbesserungen in der Anwenderfreundlichkeit zur Folge hat.');
  WRITELN('Am Ende dieses Kurses werden Sie den kompletten Quellltext des BGI-Aufsatzes im');
  WRITE  ('Programmers DiskMAG finden, den Sie dann auch ohne Restriktionen in eigenen Pro-');
  WRITELN('grammen nutzen knnen.');
  WRITELN;
  WRITELN('Wir sind natrlich nicht nur fr PASCAL-Programmierer da. Den kompletten BGI-');
  WRITELN('Aufsatz gibt es natrlich auch fr C- und C++-Programmierer. Wenden Sie sich');
  WRITELN('bei Interesse bitte an:');
  WRITELN;
  WRITELN('                    BSR-SOTWARGroup Genthin');
  WRITELN('                    -    DJ ByteDisaster    -');
  WRITELN('                     groe Waldstr. 39');
  WRITELN('                     39307 Genthin-Altenplatow');
END.