/*
/* PLAYRAW.C
/* =========
/*
/* Dieses Programm dient zum Abspielen von sogenannten RAW-Daten. RAW deshalb,
/* weil auer den blanken Datenbytes keinerlei Informationen in der Datei ent-
/* halten sind. Das hier vorliegende Programm soll nur die entsprechenden
/* Funktionen der Library SBLASTER demonstrieren und ist deshalb stark ver-
/* einfacht - es knnen nur Dateien abgespielt werden, die kleiner sind als
/* 64 KByte und sie werden grundstzlich mit einer Samplingrate von 8000 abge-
/* spielt. Sie knnen die Funktion des Programms mit der Datei SAMPLE.RAW
/* ausprobieren.
/*
/* (c) 1995 by DJ ByteDisaster (schoeneb@hppool.cs.tu-magdeburg.de)
*/

#include <stdio.h>
#include "sblaster.h"

void main(argc,argv)
int    argc;
char **argv;
{
 FILE *fp;
 long length;
 char *daten;

 if ((fp=fopen(argv[1],"rb"))==NULL)
 {
  fprintf(stderr,"\r\nFalscher oder fehlender Dateinamen (xxxxx.raw)\r\n");
  exit(1);
 }
 fseek(fp,0L,2);
 length=ftell(fp);
 daten=(char *)malloc(length);
 fread(daten,length,1,fp);
 sb_initialize();
 sb_speakeron();
 fprintf(stdout,"\r\n%s %x\r\n","SoundBlaster-Karte gefunden an Adresse",dsp_baseport);
 sb_settimeconst(256UL-(1000000UL/8000));
 sb_dmaout(daten,length);
}