/*      SOUNDBLASTER-Library
/*      ====================
/*
/* Soundblaster-Librayfile
/*
/* (c) 1995 by BSR-SOFTWAREGroup Sachsen-Anhalt
*/

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include "sblaster.h"

unsigned int  dsp_baseport=0x220;      /* Portadresse des DSP      */
unsigned char dsp_interrupt=0x05;      /* Interrupt des DSP        */
int           sbinitialized=(1!=1);   /* Initialisierungs-Flag    */
char          sbversion[6]={'0','.','0','0',0,0};
unsigned char sbversmaj=0;
unsigned char sbversmin=0;

/* Soundblaster-Reset */
int sb_reset()
{
 unsigned char ct,stat;

 outportb(dsp_baseport+0x06,0x01);
 for (ct=100;ct;ct--);
 outportb(dsp_baseport+0x06,0x00);
 stat=0;
 ct=100;
 while ((stat!=0xAA) && (ct))
 {
  stat=inportb(dsp_baseport+0x0E);
  stat=inportb(dsp_baseport+0x0A);
  ct--;
 }
 return(stat==0xAA);
}

void sb_dmaout(data,len)
char *data;
long len;
{
 unsigned long physical;
 long aligned_physical;

 physical=((unsigned long)FP_OFF(data))+(((unsigned long)FP_SEG(data))<<4);
 aligned_physical=physical+0x0FFFFL;
 aligned_physical&=0xF0000L;
 len--;
 outportb(0x0A,0x05);
 outportb(0x0C,0x00);
 outportb(0x0B,0x49);
 outportb(0x02,(unsigned char)(aligned_physical&0xFF));
 outportb(0x02,(unsigned char)((aligned_physical>>8)&0xFF));
 outportb(0x83,(unsigned char)((aligned_physical>>16)&0xFF));
 outportb(0x03,(unsigned char)(len&0xFF));
 outportb(0x03,(unsigned char)((len>>8)&0xFF));
 outportb(0x0A,0x01);
 sb_writebyte(0x14);
 sb_writebyte((unsigned char)(len&0xFF));
 sb_writebyte((unsigned char)((len>>8)&0xFF));

}

/* Portadresse des DSP feststellen */
int sb_regdetect()
{
 unsigned int port,last;
 int          regdetected;

 regdetected=(1!=1);
 port=0x210;
 last=0x280;
 while ((!regdetected) && (port<=last))
 {
  dsp_baseport=port;
  regdetected=sb_reset();
  if (!regdetected) port+=0x10;
 }
 return regdetected;
}

/* Ein Byte direkt ber den DSP schaufeln           */
void sb_writebyte(wb)
unsigned char wb;
{
 while (inportb(dsp_baseport+0x0C)>=0x80);    /* warten bis DSP bereit ist */
 outportb(dsp_baseport+0x0C,wb);
}

/* prfen, ob Soundblaster-Karte installiert ist... */
void sb_initialize()
{
 if (!sb_regdetect())
 {
  fprintf(stderr,"Keine Soundblaster-Karte gefunden...");
  exit(1);
 }
}

/* Ein Byte vom DSP empfangen */
unsigned char sb_readbyte()
{
 while (inportb(dsp_baseport+0x0A)==0xAA);  /* wieder mal auf das Teil warten */
 return (unsigned char)(inportb(dsp_baseport+0x0A));
}

/* jetzt wird's ganz direkt */
void sb_directwrite(v)
unsigned char v;
{
 sb_writebyte(0x10);
 sb_writebyte(v);
}

/* Timekonstante setzen */
void sb_settimeconst(tc)
unsigned char tc;
{
 sb_writebyte(0x40);
 sb_writebyte(tc);
}

/* Lautsprecher ein */
void sb_speakeron()   
{
 sb_writebyte(0xD1);
}

/* Lautsprecher aus */
void sb_speakeroff()
{
 sb_writebyte(0xD3);
}

/* DMA-Ausgabe unterbrechen */
void sb_stopdma()
{
 sb_writebyte(0xD0);
}

/* Mit sb_stopdma() unterbrochene Ausgabe fortsetzen */
void sb_continuedma()
{
 sb_writebyte(0xD4);
}

/* DSP-Version festellen */
void sb_getversion()
{
 sb_writebyte(0xE1);
 sbversmaj=sb_readbyte();
 sbversmin=sb_readbyte();
 sbversion[0]=sbversmaj+0x30;
 if (sbversmin<10) sbversion[3]=sbversmin+0x30; else
 {
  sbversion[2]=(unsigned char)(sbversmin/10)+0x30;
  sbversion[3]=(sbversmin % 10)+0x30;
 }
}