(***************************************************************************)
(**   Programm                                                 WOLFVIEW   **)
(**   -----------------------------------------------------------------   **)
(**   Dieses Programm dient zur Verdeutlichung des Umganges mit Wolfen-   **)
(**   stein-Leveln. Der Einfachheit halber werden nut die MAP-Daten an-   **)
(**   gezeigt, die Darstellung der Objektdaten mge der interessierte     **)
(**   Leser selbst ergnzen.                                              **)
(**   -----------------------------------------------------------------   **)
(**   (c) 1994,95 by BSR-SOFTWAREGroup Sachsen-Anhalt fr PDM             **)
(***************************************************************************)

Program WolfView;
Uses Drivers,                   (* TURBO-VISION-UNIT fr KeyBoard-Konstanten *)
     Dos,                       (* Standard-DOS-Unit                         *)
     Crt,                       (* Standard-Textmode-Unit                    *)
     CrtFxLib;                  (* BSR-Unit : erweiterter Textmodus          *)
{---------------------------------------------------------------------------}
{***************************************************************************}
{**                     Globale Datentypen                                **}
{***************************************************************************}
TYPE
  CompressedDataRec     = Record
                            Size        : Word;
                            Content     : Pointer;
                          End;
  {-------------------------------------------------------------------------}
  MapEntry              = Record
                            ContentDescriptor   : Word;
                            InternalCode        : LongInt;
                            Name                : String[37];
                          End;
  {-------------------------------------------------------------------------}
  LevelGrid             = Array[0..63] Of Array[0..63] Of Word;
  LevelIndexRec         = Array[0..2] Of LongInt;

Procedure LoadLevel(LevelNummer : Integer);Forward;

CONST PredefinedMaps : Array[1..95] Of MapEntry = (
  (ContentDescriptor : $0000; InternalCode : $20002000; Name : 'Leerfeld'),
  (ContentDescriptor : $0001; InternalCode : $B107B107; Name : 'Graustein (Typ 1)'),
  (ContentDescriptor : $0002; InternalCode : $B007B007; Name : 'Graustein (Typ 2)'),
  (ContentDescriptor : $0003; InternalCode : $42784278; Name : 'Graustein mit Banner'),
  (ContentDescriptor : $0004; InternalCode : $48784878; Name : 'Graustein mit Hitlerbild'),
  (ContentDescriptor : $0005; InternalCode : $BA70BA70; Name : 'Gefngniszelle'),
  (ContentDescriptor : $0006; InternalCode : $45784578; Name : 'Graustein mit Adler'),
  (ContentDescriptor : $0007; InternalCode : $D770D770; Name : 'Gefngniszelle mit Knochen'),
  (ContentDescriptor : $0008; InternalCode : $20102010; Name : 'Blaustein (Typ 1)'),
  (ContentDescriptor : $0009; InternalCode : $DB19DB19; Name : 'Blaustein (Typ 2)'),
  (ContentDescriptor : $000a; InternalCode : $45604560; Name : 'Holz mit Adler'),
  (ContentDescriptor : $000b; InternalCode : $48604860; Name : 'Holz mit Hitlerbild'),
  (ContentDescriptor : $000c; InternalCode : $20602060; Name : 'Holzpanl'),
  (ContentDescriptor : $000d; InternalCode : $DE07DD07; Name : 'Leveleingang'),
  (ContentDescriptor : $000e; InternalCode : $53305330; Name : 'Stahlplatte mit Schild'),
  (ContentDescriptor : $000f; InternalCode : $20302030; Name : 'Stahlplatte'),
  (ContentDescriptor : $0010; InternalCode : $4C204C20; Name : 'Landschaft'),
  (ContentDescriptor : $0011; InternalCode : $20402040; Name : 'Rote Ziegel'),
  (ContentDescriptor : $0012; InternalCode : $77207720; Name : 'Rote Ziegel mit Wappen'),
  (ContentDescriptor : $0013; InternalCode : $20502050; Name : 'Lila Tapete'),
  (ContentDescriptor : $0014; InternalCode : $53505350; Name : 'Rote Ziegel mit Schild'),
  (ContentDescriptor : $0015; InternalCode : $B10EB10E; Name : 'Fahrstuhl 1'),
  (ContentDescriptor : $0016; InternalCode : $B00Eb00E; Name : 'Fahrstuhl 2'),
  (ContentDescriptor : $0017; InternalCode : $4B604B60; Name : 'Holz mit Eisernem Kreuz'),
  (ContentDescriptor : $0018; InternalCode : $B072B072; Name : 'Graustein mit Schleim'),
  (ContentDescriptor : $0019; InternalCode : $DB08DB08; Name : 'Grauer Block'),
  (ContentDescriptor : $001a; InternalCode : $B072B072; Name : 'Graustein mit Schleim'),
  (ContentDescriptor : $001b; InternalCode : $B278B278; Name : 'Graustein (Typ 3)'),
  (ContentDescriptor : $001c; InternalCode : $53785378; Name : 'Graustein mit Schild'),
  (ContentDescriptor : $001d; InternalCode : $B060B060; Name : 'Braunstein'),
  (ContentDescriptor : $001e; InternalCode : $B064B064; Name : 'Braunsteim mit Blut'),
  (ContentDescriptor : $001f; InternalCode : $B064B064; Name : 'Braunsteim mit Blut'),
  (ContentDescriptor : $0020; InternalCode : $B064B064; Name : 'Braunsteim mit Blut'),
  (ContentDescriptor : $0021; InternalCode : $FE30FE30; Name : 'Glas'),
  (ContentDescriptor : $0022; InternalCode : $53015301; Name : 'Blauer Totenschdel'),
  (ContentDescriptor : $0023; InternalCode : $CB78CB78; Name : 'Grauziegel'),
  (ContentDescriptor : $0024; InternalCode : $42015301; Name : 'BLUE SWASTIKA'),
  (ContentDescriptor : $0025; InternalCode : $76787678; Name : 'Graustein mit "Vent"'),
  (ContentDescriptor : $0026; InternalCode : $DD12DD34; Name : 'Buntstein'),
  (ContentDescriptor : $0027; InternalCode : $CB78CB78; Name : 'Grauziegel'),
  (ContentDescriptor : $0028; InternalCode : $CB19CB19; Name : 'Blauziegel'),
  (ContentDescriptor : $0029; InternalCode : $53105310; Name : 'Blaustein mit Schild'),
  (ContentDescriptor : $002a; InternalCode : $B060B060; Name : 'Braunstein'),
  (ContentDescriptor : $002b; InternalCode : $4B784B78; Name : 'Graustein mit Karte'),
  (ContentDescriptor : $002c; InternalCode : $B060B060; Name : 'Braunstein'),
  (ContentDescriptor : $002d; InternalCode : $B060B060; Name : 'Braunstein'),
  (ContentDescriptor : $002e; InternalCode : $B060B060; Name : 'Braunstein'),
  (ContentDescriptor : $002f; InternalCode : $42604260; Name : 'Braunstein mit Banner'),
  (ContentDescriptor : $0030; InternalCode : $2F6E5C6E; Name : 'HolzPanl mit Strahlen'),
  (ContentDescriptor : $0031; InternalCode : $50785078; Name : 'Graustein mit HitlerPoster'),
  (ContentDescriptor : $005a; InternalCode : $DE072007; Name : 'offene Tr'),
  (ContentDescriptor : $005b; InternalCode : $C407C407; Name : 'offene Tr'),
  (ContentDescriptor : $005c; InternalCode : $DE0E200E; Name : 'abgeschlossene Tr (gelber Schlssel)'),
  (ContentDescriptor : $005d; InternalCode : $C40EC40E; Name : 'abgeschlossene Tr (gelber Schlssel)'),
  (ContentDescriptor : $005e; InternalCode : $DE092009; Name : 'abgeschlossene Tr (blauer Schlssel)'),
  (ContentDescriptor : $005f; InternalCode : $C409C409; Name : 'abgeschlossene Tr (blauer Schlssel)'),
  (ContentDescriptor : $0064; InternalCode : $DE0C200C; Name : 'Fahrstuhltr'),
  (ContentDescriptor : $006a; InternalCode : $77047704; Name : 'Fuboden (Wache)'),
  (ContentDescriptor : $006b; InternalCode : $20002000; Name : 'Fuboden (Typ 6B)'),
  (ContentDescriptor : $006c; InternalCode : $20002000; Name : 'Fuboden (Typ 6C)'),
  (ContentDescriptor : $006d; InternalCode : $20002000; Name : 'Fuboden (Typ 6D)'),
  (ContentDescriptor : $006e; InternalCode : $20002000; Name : 'Fuboden (Typ 6E)'),
  (ContentDescriptor : $006f; InternalCode : $20002000; Name : 'Fuboden (Typ 6F)'),
  (ContentDescriptor : $0070; InternalCode : $20002000; Name : 'Fuboden (Typ 70)'),
  (ContentDescriptor : $0071; InternalCode : $20002000; Name : 'Fuboden (Typ 71)'),
  (ContentDescriptor : $0072; InternalCode : $20002000; Name : 'Fuboden (Typ 72)'),
  (ContentDescriptor : $0073; InternalCode : $20002000; Name : 'Fuboden (Typ 73)'),
  (ContentDescriptor : $0074; InternalCode : $20002000; Name : 'Fuboden (Typ 74)'),
  (ContentDescriptor : $0075; InternalCode : $20002000; Name : 'Fuboden (Typ 75)'),
  (ContentDescriptor : $0076; InternalCode : $20002000; Name : 'Fuboden (Typ 76)'),
  (ContentDescriptor : $0077; InternalCode : $20002000; Name : 'Fuboden (Typ 77)'),
  (ContentDescriptor : $0078; InternalCode : $20002000; Name : 'Fuboden (Typ 78)'),
  (ContentDescriptor : $0079; InternalCode : $20002000; Name : 'Fuboden (Typ 79)'),
  (ContentDescriptor : $007a; InternalCode : $20002000; Name : 'Fuboden (Typ 7A)'),
  (ContentDescriptor : $007b; InternalCode : $20002000; Name : 'Fuboden (Typ 7B)'),
  (ContentDescriptor : $007c; InternalCode : $20002000; Name : 'Fuboden (Typ 7C)'),
  (ContentDescriptor : $007d; InternalCode : $20002000; Name : 'Fuboden (Typ 7D)'),
  (ContentDescriptor : $007e; InternalCode : $20002000; Name : 'Fuboden (Typ 7E)'),
  (ContentDescriptor : $007f; InternalCode : $20002000; Name : 'Fuboden (Typ 7F)'),
  (ContentDescriptor : $0080; InternalCode : $20002000; Name : 'Fuboden (Typ 80)'),
  (ContentDescriptor : $0081; InternalCode : $20002000; Name : 'Fuboden (Typ 81)'),
  (ContentDescriptor : $0082; InternalCode : $20002000; Name : 'Fuboden (Typ 82)'),
  (ContentDescriptor : $0083; InternalCode : $20002000; Name : 'Fuboden (Typ 83)'),
  (ContentDescriptor : $0084; InternalCode : $20002000; Name : 'Fuboden (Typ 84)'),
  (ContentDescriptor : $0085; InternalCode : $20002000; Name : 'Fuboden (Typ 85)'),
  (ContentDescriptor : $0086; InternalCode : $20002000; Name : 'Fuboden (Typ 86)'),
  (ContentDescriptor : $0087; InternalCode : $20002000; Name : 'Fuboden (Typ 87)'),
  (ContentDescriptor : $0088; InternalCode : $20002000; Name : 'Fuboden (Typ 88)'),
  (ContentDescriptor : $0089; InternalCode : $20002000; Name : 'Fuboden (Typ 89)'),
  (ContentDescriptor : $008a; InternalCode : $20002000; Name : 'Fuboden (Typ 8A)'),
  (ContentDescriptor : $008b; InternalCode : $20002000; Name : 'Fuboden (Typ 8B)'),
  (ContentDescriptor : $008c; InternalCode : $20002000; Name : 'Fuboden (Typ 8C)'),
  (ContentDescriptor : $008d; InternalCode : $20002000; Name : 'Fuboden (Typ 8D)'),
  (ContentDescriptor : $008e; InternalCode : $20002000; Name : 'Fuboden (Typ 8E)'),
  (ContentDescriptor : $008f; InternalCode : $20002000; Name : 'Fuboden (Typ 8F)'));
Var
  GameVersion           : Real;
  LevelIndices          : Array[0..59] Of LevelIndexRec;
  MaxLevel,Currentlevel : Integer;
  HeadFile              : File;
  MapFile               : File;
  Maps,Objs             : LevelGrid;
  LevelRaw              : CompressedDataRec;
{***************************************************************************}
{**                     LOKALE SUPPORT-Routinen                           **}
{***************************************************************************}

Procedure A7A8_Decompress(Var Src,Dest : CompressedDataRec);
var s, o,
    s2, o2,
    index, index2,
    size,
    length,
    data,
    newsize  : word;
    goback1  : byte;
    goback2  : word;
    i        : integer;

begin
  s := seg(src.content^);
  o := ofs(src.content^);
  index := 0;
  move(mem[s:o+index], dest.size, 2);
  inc(index, 2);
  getmem(dest.content, dest.size);
  s2 := seg(dest.content^);
  o2 := ofs(dest.content^);
  index2 := 0;

  repeat
    move(mem[s:o+index], data, 2);
    inc(index, 2);
    case hi(data) of
      $a7: begin
             length := lo(data);
             move(mem[s:o+index], goback1, 1);
             inc(index, 1);
             move(mem[s2:o2+index2-goback1*2], mem[s2:o2+index2], length*2);
             inc(index2,length*2);
           end;
      $a8: begin
             length := lo(data);
             move(mem[s:o+index], goback2, 2);
             inc(index, 2);
             move(mem[s2:o2+goback2*2], mem[s2:o2+index2], length*2);
             inc(index2, length*2);
           end;
      else begin
             move(data, mem[s2:o2+index2], 2);
             inc(index2, 2);
           end;
    end;
  until index=src.size;
End;
{---------------------------------------------------------------------------}
Procedure ABCD_Decompress(Var SrcData : CompressedDataRec;Var Dest : LevelGrid);
var i,x,y : integer;
    s,o,
    data,
    count : word;
    temp : compressedDataRec;

begin
  if GAMEVERSION = 1.1 then
    a7a8_decompress(srcdata, temp)
  else
    temp := srcdata;

  x := 0;
  y := 0;
  s := seg(temp.content^);
  o := ofs(temp.content^);
  inc(o, 2);
  while (y<64) do
    begin
      move(mem[s:o], data, 2);
      inc(o, 2);
      if data=$abcd then
        begin
          move(mem[s:o], count, 2);
          inc(o, 2);
          move(mem[s:o], data, 2);
          inc(o, 2);
          for i:=1 to count do
            begin
              dest[x,y]:= data;
              inc(x);
              if x=64 then
                begin
                  x := 0;
                  inc(y);
                end;
            end;
        end
      else
        begin
          dest[x,y] := data;
          inc(x);
          if x=64 then
            begin
              x := 0;
              inc(y);
            end;
        end;
    end;
  if GAMEVERSION=1.1 then
    freemem(temp.content, temp.size);
end;
{---------------------------------------------------------------------------}
Procedure InitializeMapData;
Var
  HeadFileName,MapFileName          : String;
  HeadExt,MapExt                    : ExtStr;
  Loop                              : Integer;
  LevelIndex                        : LongInt;
  DirInfo                           : SearchRec;
Begin
  FindFirst('MAPHEAD.*',archive,DirInfo);
  If DosError<>0 Then
  Begin
    TextMode(co80);
    Writeln('WOLFVIEW 1.0 - Fehler beim ffnen der MAPHEAD-Datei');
    Halt(1);
  End else HeadFileName:=DirInfo.Name;
  FindFirst('GAMEMAPS.*',archive,DirInfo);
  If DosError<>0 Then
  Begin
    FindFirst('MAPTEMP.*',archive,DirInfo);
    If (DosError<>0) Then
    Begin
      TextMode(co80);
      Writeln('WOLFVIEW 1.0 - Fehler beim ffnen der MAP-Datei ');
      Halt(1);
    End;
  End;
  MapFilename:=DirInfo.Name;
  HeadFileName:=FExpand(HeadFileName);
  MapFileName:=FExpand(MapFileName);
  HeadExt:=Copy(HeadFileName,Length(HeadFileName)-3,4);
  MapExt:=Copy(MapFileName,Length(MapFileName)-3,4);
  If (HeadExt<>MapExt) Then
  Begin
    TextMode(co80);
    Writeln('WOLFVIEW 1.0 - Incompatible MAP- und HEAD-Dateien');
    Halt(1);
  End;
  If MapExt='.WL1' Then
  Begin
    If MapFileName='MAPTEMP.WL1' Then GameVersion:=1.0 else GameVersion:=1.1;
    MaxLevel:=9;
  End else
  If MapExt='.WL3' Then
  Begin
    GameVersion:=1.1;
    MaxLevel:=29;
  End else
  If MapExt='.WL6' Then
  Begin
    GameVersion:=1.1;
    MaxLevel:=59;
  End;
  CurrentLevel:=1;
  Assign(HeadFile,HeadFileName);
  Reset(HeadFile,1);
  Assign(MapFile,MapFileName);
  Reset(MapFile,1);
End;
{---------------------------------------------------------------------------}
Procedure FillLevelMap;
Var
  Loop1,Loop2,Loop3             : Integer;
Begin
  For Loop1:=0 to 63 Do
  Begin
    For Loop2:=0 to 63 Do
    Begin
      For Loop3:=1 to 95 Do
      If maps[Loop1,Loop2] = PredefinedMaps[Loop3].ContentDescriptor Then
      Begin
        mem[$B800:320*Loop2+640+(loop1 shl 2)+2]:=(PredefinedMaps[Loop3].Internalcode and $FF000000) shr 24;
        mem[$B800:320*Loop2+640+(loop1 shl 2)+3]:=(PredefinedMaps[Loop3].Internalcode and $00FF0000) shr 16;
        mem[$B800:320*Loop2+640+(loop1 shl 2)+4]:=(PredefinedMaps[Loop3].Internalcode and $0000FF00) shr 8;
        mem[$B800:320*Loop2+640+(loop1 shl 2)+5]:=(PredefinedMaps[Loop3].Internalcode and $000000FF);
      end;
    End;
  End;
End;
{---------------------------------------------------------------------------}
Procedure InitializeDisplay;
Var
  Loop          : Integer;
Begin
  CrtFx.Init(160);
  CrtFx.Clear($1e);
  crtfx.DisplayString(0,0,$70,'                       Castle Wolfenstein - LevelmapViewer 1.0                  '+
                              '                                                                                ');
  crtfx.Frame(0,1,129,66,$1F,FALSE);
  For Loop:=1 to 95 Do
  begin
    mem[$B800:320*Loop+260]:=(PredefinedMaps[Loop].Internalcode and $FF000000) shr 24;
    mem[$B800:320*Loop+261]:=(PredefinedMaps[Loop].Internalcode and $00FF0000) shr 16;
    mem[$B800:320*Loop+262]:=(PredefinedMaps[Loop].Internalcode and $0000FF00) shr 8;
    mem[$B800:320*Loop+263]:=(PredefinedMaps[Loop].Internalcode and $000000FF);
    CrtFx.Displaystring(135,Loop,$1E,Copy(PredefinedMaps[Loop].Name,1,160-135));
  End;
  LoadLevel(1);
End;
{---------------------------------------------------------------------------}
Procedure ShutDown;
Begin
  crtfx.Kill;
  TextMode(Co80);
End;
{---------------------------------------------------------------------------}
Procedure LoadLevel(LevelNummer : Integer);
Var
  LevelPtr              : LongInt;
  MapPtr                : LongInt;
  ObjPtr                : LongInt;
  ExtraPtr              : LongInt;
  MapSize               : Word;
  ObjSize               : Word;
  ExtraSize             : Word;
  Name                  : String[16];
  IDSignum              : LongInt;
  GridWidth,GridHeight  : Word;
Begin
  Seek(HeadFile,2+(LevelNummer-1)*4);
  BlockRead(HeadFile,LevelPtr,4);
  Seek(MapFile,LevelPtr);
  BlockRead(MapFile,MapPtr,4);
  BlockRead(MapFile,ObjPtr,4);
  BlockRead(MapFile,ExtraPtr,4);
  BlockRead(MapFile,MapSize,2);
  BlockRead(MapFile,ObjSize,2);
  BlockRead(MapFile,Extrasize,2);
  BlockRead(MapFile,GridWidth,2);
  BlockRead(MapFile,GridHeight,2);
  name:='';
  Name[0]:=#16;
  BlockRead(MapFile,Name[1],16);
  CrtFx.DisplayString(80,0,$74,'                                   ');
  CrtFx.DisplayString(80,0,$74,'Level-Name : '+name);
  If GameVersion=1.1 Then BlockRead(MapFile,IdSignum,4);
  LevelRaw.Size:=MapSize;
  Getmem(LevelRaw.Content,MapSize);
  Seek(MapFile,MapPtr);
  BlockRead(MapFile,mem[Seg(LevelRaw.Content^):Ofs(LevelRaw.Content^)],MapSize);
  ABCD_Decompress(LevelRaw,Maps);
  CurrentLevel:=Pred(LevelNummer);
  FillLevelMap;
End;
{---------------------------------------------------------------------------}
Procedure MainLoop;
Var
  Scan              : Word;
  ScrollX,ScrollY   : Word;
  Loop              : Integer;
Begin
  Scrollx:=0;
  scrolly:=0;
  Repeat
    Scan:=0;
    If KeyPressed Then
    asm
      XOR  AX,AX
      INT  16h
      MOV  Scan,AX
    End;
    If Scan=kbUp   Then If scrollY > 0 Then
    begin
      For Loop:=1 to 16 do CrtFx.Scrolldown;
      dec(ScrollY,16);
    End;
    If scan=kbDown Then If Scrolly < 1600 Then
    Begin
      For Loop:=1 to 16 do CrtFx.Scrollup;
      inc(scrolly,16);
    end;
    If scan=kbleft Then if scrollX > 0 Then
    Begin
      For Loop:=1 to 8 Do crtfx.scrollright;
      dec(scrollx,8);
    end;
    If scan=kbright Then if scrollX<640 Then
    Begin
      For Loop:=1 to 8 Do CrtFx.scrollleft;
      inc(scrollx,8);
    end;
    If Scan=kbGrayPlus Then If CurrentLevel<MaxLevel Then LoadLevel(CurrentLevel+2);
    If Scan=kbGrayMinus Then If CurrentLevel>0 Then LoadLevel(CurrentLevel);
  Until scan=kbesc;
end;

begin
  InitializeMapData;
  InitializeDisplay;
  MainLoop;
  ShutDown;
end.